﻿using ComputersShopContracts.Attributes;
using ComputersShopDataModels.Enums;
using ComputersShopDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ComputersShopContracts.ViewModels
{
	public class OrderViewModel : IOrderModel
	{
		[Column("Номер", gridViewAutoSize: GridViewAutoSize.AllCells, isUseAutoSize: true)]
		public int Id { get; set; }
		[Column(visible: false)]
		public int ComputerId { get; set; }
		[Column(visible: false)]
		public int ClientId { get; set; }
		[Column("Данные клиента", gridViewAutoSize: GridViewAutoSize.Fill, isUseAutoSize: true)]
		public string ClientFIO { get; set; } = string.Empty;
		[Column(visible: false)]
		public int? ImplementerId { get; set; }
		[Column("Данные исполнителя", gridViewAutoSize: GridViewAutoSize.Fill, isUseAutoSize: true)]
		public string ImplementerFIO { get; set; } = string.Empty;
		[Column("Компьютер", gridViewAutoSize: GridViewAutoSize.AllCells, isUseAutoSize: true)]
		public string ComputerName { get; set; } = string.Empty;
		[Column("Количество", gridViewAutoSize: GridViewAutoSize.AllCells, isUseAutoSize: true)]
		public int Count { get; set; }
		[Column("Сумма", gridViewAutoSize: GridViewAutoSize.AllCells, isUseAutoSize: true)]
		public double Sum { get; set; }
		[Column("Статус", gridViewAutoSize: GridViewAutoSize.AllCells, isUseAutoSize: true)]
		public OrderStatus Status { get; set; } = OrderStatus.Неизвестен;
		[Column("Дата создания", width: 100)]
		public DateTime DateCreate { get; set; } = DateTime.Now;
		[Column("Дата выполнения", width: 100)]
		public DateTime? DateImplement { get; set; }
	}
}
